package br.usp.ime.evolvinggraph;

import java.util.ArrayList;

public class Journey {
	ArrayList<Edge> edge;
	ArrayList<Integer> time;
	int size;
	
	public Journey() {
		edge = new ArrayList<Edge>();
		time = new ArrayList<Integer>();
		size = 0;
	}
	
	public Journey(Journey j) {
		edge = new ArrayList<Edge>(j.edge);
		time = new ArrayList<Integer>(j.time);
		size = j.size;
	}
	
	public Journey(Journey j, Edge e, int t){
		edge = new ArrayList<Edge>(j.edge);
		time = new ArrayList<Integer>(j.time);
		size = j.size;
		append(e, t);
	}

	public void append(Edge e, int t){
		edge.add(e);
		time.add(t);
		size++;
	}
	
	public String toString(){
		String str = "";
		for (int i = 0; i < size; i++){
			Edge e = edge.get(i);
			str += "("+e.u.id+"["+time.get(i)+"]"+e.v.id + ")";
		}
		return str;
	}

	public Integer getArrivalDate() {
		if (time.size() == 0) return 0;
		return time.get(time.size()-1) + edge.get(edge.size()-1).getCost();
	}
	
	public Integer getTransitTime(){
		if (time.size() == 0) return 0;
		//Obs. trocado de null para 0 para o algoritmo fastestAlt
		return getArrivalDate() - time.get(0);
	}
	
	public Integer getSize(){
		return size;
	}
	
	public ArrayList<Edge> getEdges () {
		return edge;
	}
	
	public ArrayList<Integer> getTimes () {
		return time;
	}

	public void delay(Integer delay) {
		// TODO 
		for (int i = 0; i < time.size(); i++){
			time.set(i, time.get(i) + delay);
		}
	}

	public Integer getDeparture() {
		if (time.size() == 0) return null;
		return time.get(0);
	}

	public boolean canBeDelayed() {
		if (edge.size() == 0) return true;
		for (int i = 0; i < edge.size(); i++){
			Edge e = edge.get(i);
			int t = time.get(i);
			if (!e.schedule.contains(t+1))
				return false;
		}
		return true;
	}

	public boolean tryToDelay() {
		boolean delayed = false;
		for (int i = edge.size()-2; i >= 0; i--){
			 Integer newTime = edge.get(i).lastDepartureBefore(time.get(i));
			 if (newTime > time.get(i)){
				 time.set(i, newTime);
				 delayed = true;
			 }
		}
		return delayed;
	}
}
