package br.usp.ime.priorityqueueelement;

import br.usp.ime.evolvinggraph.Journey;
import br.usp.ime.evolvinggraph.Node;
import br.usp.ime.journeyclass.JourneyClass;

public class FastestElement implements Comparable<FastestElement>{
	private Node u;
	private JourneyClass journeyClass;

	public FastestElement(Node u, Journey journey) {
		super();
		this.u = u;
		this.journeyClass = new JourneyClass();
		this.journeyClass.setJourney(journey);
	}
	
	public FastestElement(Node u, Journey journey, int delay) {
		super();
		this.u = u;
		this.journeyClass = new JourneyClass();
		this.journeyClass.setJourney(journey);
		this.journeyClass.setDelay(delay);
	}
	
	public FastestElement(Node u, JourneyClass journeyClass) {
		super();
		this.u = u;
		this.journeyClass = journeyClass;
	}

	public Node getU() {
		return u;
	}

	public void setU(Node u) {
		this.u = u;
	}

	public int getArrival() {
		return journeyClass.getJourney().getArrivalDate();
	}

	public int getCost() {
		return journeyClass.getJourney().getTransitTime();
	}
	
	public int getCost(int arrival, int hops, int transit){
		Journey j = journeyClass.getJourney();
		return arrival*j.getArrivalDate() + hops*j.getSize() + transit*j.getTransitTime(); 
	}

	public Journey getJourney() {
		return journeyClass.getJourney();
	}
	
	public int getDelay(){
		return journeyClass.getDelay();
	}

	public void setJourney(JourneyClass journeyClass) {
		this.journeyClass = journeyClass;
	}

	//@Override
	public int compareTo(FastestElement o) {
		return this.getCost() - o.getCost();
	}
}
