package br.usp.ime.evolvinggraph;

import static org.junit.Assert.*;

import java.util.List;

import org.junit.Test;

import br.usp.ime.algorithms.Algorithm;
import br.usp.ime.algorithms.FastestAlgorithmAlt;
import br.usp.ime.algorithms.WeightedAlgorithm;

public class FastestAlgorithmAltTest {

	@Test
	public void testInputTeste1(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste1.in");
		Algorithm algorithm = new FastestAlgorithmAlt();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey from0to0 = journeys.get(0);
		Journey from0to1 = journeys.get(1);
		
		assertEquals(0, from0to0.getTransitTime());
		assertEquals(0, from0to1.getTransitTime());
	}	
	@Test
	public void testInputTeste2(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste2.in");
		Algorithm algorithm = new FastestAlgorithmAlt();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey journey = journeys.get(1);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(2);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(3);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(4);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(5);
		System.out.println(journey);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(6);
		assertEquals(4, journey.getTransitTime());
		journey = journeys.get(7);
		assertEquals(3, journey.getTransitTime());
		journey = journeys.get(8);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(9);
		assertEquals(4, journey.getTransitTime());
		journey = journeys.get(10);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(11);
		assertEquals(1, journey.getTransitTime());
	}	
	@Test
	public void testInputTeste3(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste3.in");
		Algorithm algorithm = new FastestAlgorithmAlt();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey journey = journeys.get(1);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(2);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(3);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(4);
		assertEquals(0, journey.getTransitTime());
	}
	@Test
	public void testInputTeste4(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste4.in");
		Algorithm algorithm = new FastestAlgorithmAlt();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey journey = journeys.get(1);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(2);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(3);
		assertEquals(3, journey.getTransitTime());
		journey = journeys.get(4);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(5);
		assertEquals(2, journey.getTransitTime());
		journey = journeys.get(6);
		assertEquals(3, journey.getTransitTime());
		journey = journeys.get(7);
		assertEquals(4, journey.getTransitTime());
	}

	@Test
	public void testInputTeste5(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste5.in");
		WeightedAlgorithm algorithm = new WeightedAlgorithm(1, 0);
		
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(1));
		Journey journey = journeys.get(0);
		System.out.println("1,0\t" + journey);
		
		algorithm.setArrivalTimeWeight(2);
		algorithm.setHopCountWeight(1);
		journeys = algorithm.calculate(eg, eg.getNode(1));
		journey = journeys.get(0);
		System.out.println("2,1\t" + journey);
		
		algorithm.setArrivalTimeWeight(3);
		algorithm.setHopCountWeight(2);
		journeys = algorithm.calculate(eg, eg.getNode(1));
		journey = journeys.get(0);
		System.out.println("3,2\t" + journey);
		
		algorithm.setArrivalTimeWeight(0);
		algorithm.setHopCountWeight(1);
		journeys = algorithm.calculate(eg, eg.getNode(1));
		journey = journeys.get(0);
		System.out.println("0,1\t" + journey);
		
	}
}
