package br.usp.ime.evolvinggraph;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.util.List;

import org.junit.Test;

import br.usp.ime.algorithms.Algorithm;
import br.usp.ime.algorithms.FastestAlgorithm3;

public class FastestAlgorithmTest {

	@Test
	public void testInputTeste1(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste1.in");
		Algorithm algorithm = new FastestAlgorithm3();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey from0to0 = journeys.get(0);
		Journey from0to1 = journeys.get(1);

		assertNotNull(from0to0);
		assertNotNull(from0to1);
		assertEquals(null, from0to0.getTransitTime());
		assertEquals(0, from0to1.getTransitTime());
	}	
	@Test
	public void testInputTeste2(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste2.in");
		Algorithm algorithm = new FastestAlgorithm3();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey journey = journeys.get(1);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(2);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(3);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(4);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(5);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(6);
		assertEquals(4, journey.getTransitTime());
		journey = journeys.get(7);
		assertEquals(3, journey.getTransitTime());
		journey = journeys.get(8);
		//Jornada nao foremost:
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(9);
		assertEquals(4, journey.getTransitTime());
		journey = journeys.get(10);
		//Jornada nao foremost:
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(11);
		//Jornada nao foremost:
		assertEquals(1, journey.getTransitTime());
	}	
	@Test
	public void testInputTeste3(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste3.in");
		Algorithm algorithm = new FastestAlgorithm3();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey journey = journeys.get(1);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(2);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(3);
		assertEquals(0, journey.getTransitTime());
		journey = journeys.get(4);
		assertEquals(0, journey.getTransitTime());
	}
	@Test
	public void testInputTeste4(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste4.in");
		Algorithm algorithm = new FastestAlgorithm3();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey journey = journeys.get(1);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(2);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(3);
		assertEquals(3, journey.getTransitTime());
		journey = journeys.get(4);
		assertEquals(1, journey.getTransitTime());
		journey = journeys.get(5);
		//Jornada nao foremost:
		assertEquals(2, journey.getTransitTime());
		journey = journeys.get(6);
		//Jornada nao foremost:
		assertEquals(3, journey.getTransitTime());
		journey = journeys.get(7);
		//Jornada nao foremost:
		assertEquals(4, journey.getTransitTime());
	}

}
