package br.usp.ime.evolvinggraph;

import static org.junit.Assert.assertEquals;

import java.util.*;

import org.junit.Test;

import br.usp.ime.algorithms.Algorithm;
import br.usp.ime.algorithms.ShortestAlgorithm;

public class ShortestAlgorithmTest {

	@Test
	public void testInputTeste1(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste1.in");
		Algorithm algorithm = new ShortestAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		
		Journey from0to0 = journeys.get(0);
		Journey from0to1 = journeys.get(1);
		
		assertEquals(0, from0to0.getSize());
		assertEquals(1, from0to1.getSize());
	}	
	@Test
	public void testInputTeste2(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste2.in");
		Algorithm algorithm = new ShortestAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		Journey journey = journeys.get(1);
		assertEquals(1, journey.getSize());
		journey = journeys.get(2);
		assertEquals(1, journey.getSize());
		journey = journeys.get(3);
		assertEquals(1, journey.getSize());
		journey = journeys.get(4);
		assertEquals(2, journey.getSize());
		journey = journeys.get(5);
		assertEquals(3, journey.getSize());
		journey = journeys.get(6);
		assertEquals(2, journey.getSize());
		journey = journeys.get(7);
		assertEquals(4, journey.getSize());
		journey = journeys.get(8);
		assertEquals(2, journey.getSize());
		journey = journeys.get(9);
		assertEquals(5, journey.getSize());
		journey = journeys.get(10);
		assertEquals(3, journey.getSize());
		journey = journeys.get(11);
		assertEquals(3, journey.getSize());
	}	
	@Test
	public void testInputTeste3(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste3.in");
		Algorithm algorithm = new ShortestAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		Journey journey = journeys.get(1);
		assertEquals(1, journey.getSize());
		journey = journeys.get(2);
		assertEquals(1, journey.getSize());
		journey = journeys.get(3);
		assertEquals(2, journey.getSize());
		journey = journeys.get(4);
		assertEquals(4, journey.getSize());
	}
	@Test
	public void testInputTeste4(){
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraph("input/teste4.in");
		Algorithm algorithm = new ShortestAlgorithm();
		List<Journey> journeys = algorithm.calculate(eg, eg.getNode(0));
		Journey journey = journeys.get(1);
		assertEquals(1, journey.getSize());
		journey = journeys.get(2);
		assertEquals(1, journey.getSize());
		journey = journeys.get(3);
		assertEquals(2, journey.getSize());
		journey = journeys.get(4);
		assertEquals(1, journey.getSize());
		journey = journeys.get(5);
		assertEquals(2, journey.getSize());
		journey = journeys.get(6);
		assertEquals(3, journey.getSize());
		journey = journeys.get(7);
		assertEquals(2, journey.getSize());
	}
}
